<?php
/*
Plugin Name: buzzZ-Et
Plugin URI: http://blog.rswr.net/2008/05/23/wordpress-plugin-buzzz-et/
Description: Automatically displays a "buzz" button for each post. Full admin options available.
Version: 1.0.0
Author: Ryan Christenson (The RSWR Network)
Author URI: http://www.rswr.net/
*/

/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

if (!class_exists("buzzZEt")) {
	class buzzZEt {
		var $adminOptionsName = "buzzZEtAdminOptions";
		function buzzZEt() { //constructor
		}

		//Returns an array of admin options
		function getAdminOptions() {
			$bZEtAdminOptions = array('home' => 'true', 'post' => 'true', 'page' => 'true', 'tag' => 'true', 'arch' => 'true', 'srch' => 'true', 'promote' => 'true', 'display1' => 'true', 'badge' => 'true', 'body' => 'true', 'media' => 'true', 'topic' => 'true');
			$bZEtOptions = get_option($this->adminOptionsName);
			if (!empty($bZEtOptions)) {
				foreach ($bZEtOptions as $key => $option)
				$bZEtAdminOptions[$key] = $option;
			}
			update_option($this->adminOptionsName, $bZEtAdminOptions);
			return $bZEtAdminOptions;
		}
		function init() {
			$this->getAdminOptions();
		}

		//Prints out the admin page
		function printAdminPage() {
			$bZEtOptions = $this->getAdminOptions();
			if (isset($_POST['update_buzzZEtSettings'])) {
			
				// Save Settings
				if($_POST['home'] == "on") update_option('bZEt_home', "checked=on");
  				else update_option('bZEt_home', "");
  				if($_POST['post'] == "on") update_option('bZEt_post', "checked=on");
  				else update_option('bZEt_post', "");
  				if($_POST['page'] == "on") update_option('bZEt_page', "checked=on");
  				else update_option('bZEt_page', "");
  				if($_POST['tag'] == "on") update_option('bZEt_tag', "checked=on");
  				else update_option('bZEt_tag', "");
  				if($_POST['arch'] == "on") update_option('bZEt_arch', "checked=on");
  				else update_option('bZEt_arch', "");
  				if($_POST['srch'] == "on") update_option('bZEt_srch', "checked=on");
  				else update_option('bZEt_srch', "");
  				if($_POST['promote'] == "on") update_option('bZEt_promote', "checked=on");
  				else update_option('bZEt_promote', "");
  				$display1 = $_POST['display1'];
  				$badge = $_POST['badge'];
  				$body = $_POST['body'];
  				$media = $_POST['media'];
  				$topic = $_POST['topic'];

				// Update Settings
				update_option('bZEt_display1', $display1);
				update_option('bZEt_badge', $badge);
				update_option('bZEt_body', $body);
				update_option('bZEt_media', $media);
				update_option('bZEt_topic', $topic);

				// Update Admin
				update_option($this->adminOptionsName, $bZEtOptions);
?>
<div class="updated"><p><span style="font-weight:700;"><?php _e("Options Updated!", "buzzZEt");?></span></p></div>
<?php
			} else {
				// Retrieve Options
				$display1 = get_option('bZEt_display1');
				$badge = get_option('bZEt_badge');
				$body = get_option('bZEt_body');
				$media = get_option('bZEt_media');
				$topic = get_option('bZEt_topic');
			}
?>
<div class="wrap">
<form class="form-table" method="post" action="<?php _e($_SERVER["REQUEST_URI"]); ?>">
<h2>buzzZ-Et 1.0.0</h2>
<h3>Display Settings</h3>
<table width="100%">
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Hide Buttons On...
</td><td>
<span style="font-weight:700;">
<input type="checkbox" name="home" <?php _e(get_option('bZEt_home')); ?> /> Home Page (Recommended to speed up your Home Page's load time.)<br />
<input type="checkbox" name="post" <?php _e(get_option('bZEt_post')); ?> /> Posts<br />
<input type="checkbox" name="page" <?php _e(get_option('bZEt_page')); ?> /> Pages<br />
<input type="checkbox" name="tag" <?php _e(get_option('bZEt_tag')); ?> /> Tag Pages<br />
<input type="checkbox" name="arch" <?php _e(get_option('bZEt_arch')); ?> /> Archives (This is all Category, Author and Date based pages)<br />
<input type="checkbox" name="srch" <?php _e(get_option('bZEt_srch')); ?> /> Search Page Results<br />
<span style="color:red;">Single Page or Post</span>
<br />Note: Add the following html snippet to any page or post you would like to the hide the "Yahoo! Buzz" button on.
<br />&lt;!--buzzZ=none--&gt;
</span>
</td></tr>
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Button Position
</td><td>
<select id="display1" name="display1">
	<option value="" <?php _e($display1=="" ? "selected" : ""); ?>>Top Right</option>
	<option value="left" <?php _e($display1=="left" ? "selected" : ""); ?>>Top Left</option>
	<option value="bottomL" <?php _e($display1=="bottomL" ? "selected" : ""); ?>>Bottom Left</option>
	<option value="bottomR" <?php _e($display1=="bottomR" ? "selected" : ""); ?>>Bottom Right</option>
</select>
</td></tr>
</table>
<h3>Button Settings</h3>
<table width="100%">
<tr valign="top">
<th scope="row" style="text-align:left; vertical-align:top;">
Badge Type
</td><td>
<select id="badge" name="badge">
	<option value="square" <?php _e($badge=="square" ? "selected" : ""); ?>>Square</option>
	<option value="text-votes" <?php _e($badge=="text-votes" ? "selected" : ""); ?>>Text Votes</option>
	<option value="logo" <?php _e($badge=="logo" ? "selected" : ""); ?>>Icon (Without Text)</option>
	<option value="text" <?php _e($badge=="text" ? "selected" : ""); ?>>Icon (With Text Link)</option>
	<option value="small-votes" <?php _e($badge=="small-votes" ? "selected" : ""); ?>>Small Votes</option>
	<option value="medium-votes" <?php _e($badge=="medium-votes" ? "selected" : ""); ?>>Medium Votes</option>
	<option value="large-votes" <?php _e($badge=="large-votes" ? "selected" : ""); ?>>Large Votes</option>
	<option value="small" <?php _e($badge=="small" ? "selected" : ""); ?>>Small Button</option>
	<option value="medium" <?php _e($badge=="medium" ? "selected" : ""); ?>>Medium Button</option>
	<option value="large" <?php _e($badge=="large" ? "selected" : ""); ?>>Large Button</option>
</select>
</td>
<td>
<img src="<?php echo buzzZEt_Url(); ?>buzz-examples.png" width="550px" height="300px" />
</td></tr>
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Summary
</td><td colspan="2">
<select id="body" name="body">
	<option value="" <?php _e($body=="" ? "selected" : ""); ?>>Manual (Blank Summary)</option>
	<option value="150" <?php _e($body=="150" ? "selected" : ""); ?>>150 Charachter Summary</option>
	<option value="250" <?php _e($body=="250" ? "selected" : ""); ?>>250 Charachter Summary</option>
	<option value="350" <?php _e($body=="350" ? "selected" : ""); ?>>350 Charachter Summary</option>
</select>
</td></tr>
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Media
</td><td colspan="2">
<select id="media" name="media">
	<option value="text" <?php _e($media=="text" ? "selected" : ""); ?>>Text (News)</option>
	<option value="video" <?php _e($media=="video" ? "selected" : ""); ?>>Video</option>
	<option value="image" <?php _e($media=="image" ? "selected" : ""); ?>>Image</option>
</select>
<br /><span style="color:red;font-weight:700;">The default type of media being submitted.</span>
<span style="font-weight:700;">
<br />Note: If you need to use multiple types of media, add one of the following html snippets to your page or post.
<br /> &lt;!--buzzZM=text--&gt;
<br /> &lt;!--buzzZM=image--&gt;
<br /> &lt;!--buzzZM=video--&gt;
</span>
</td></tr>
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Category
</td><td colspan="2">
<select id="topic" name="topic">
	<option value="" <?php _e($topic=="" ? "selected" : ""); ?>>Blank</option>
	<option value="business" <?php _e($topic=="business" ? "selected" : ""); ?>>Business</option>
	<option value="entertainment" <?php _e($topic=="entertainment" ? "selected" : ""); ?>>Entertainment</option>
	<option value="health" <?php _e($topic=="health" ? "selected" : ""); ?>>Health</option>
	<option value="images" <?php _e($topic=="images" ? "selected" : ""); ?>>Images</option>
	<option value="lifestyle" <?php _e($topic=="lifestyle" ? "selected" : ""); ?>>Lifestyle</option>
	<option value="politics" <?php _e($topic=="politics" ? "selected" : ""); ?>>Politics</option>
	<option value="science" <?php _e($topic=="science" ? "selected" : ""); ?>>Science</option>
	<option value="sports" <?php _e($topic=="sports" ? "selected" : ""); ?>>Sports</option>
	<option value="travel" <?php _e($topic=="travel" ? "selected" : ""); ?>>Travel</option>
	<option value="usnews" <?php _e($topic=="usnews" ? "selected" : ""); ?>>US News</option>
	<option value="video" <?php _e($topic=="video" ? "selected" : ""); ?>>Video</option>
	<option value="world-news" <?php _e($topic=="world-news" ? "selected" : ""); ?>>World News</option>
</select>
<br /><span style="color:red;font-weight:700;">Leave this set to "Blank" if you want the poster to choose the category.</span>
</td></tr>
</table>
<h3>Other Settings</h3>
<table width="100%">
<tr>
<th scope="row" style="text-align:left; vertical-align:top;">
Help promote buzzZ-Et?
</td><td>
<input type="checkbox" name="promote" <?php _e(get_option('bZEt_promote')); ?> />  <span style="font-weight:700;">Place a support link at the bottom of each post/page that uses a "Yahoo! Buzz" button. Thanks for your support!</span>
</td></tr>
</table>
	<div class="submit">
		<input type="submit" name="update_buzzZEtSettings" value="<?php _e('Update Settings', 'buzzZEt') ?>" />
	</div>
</form>
</div>
<?php
		}
	}
}

// Get Plugin URL
function buzzZEt_Url() {
	$path = dirname(__FILE__);
	$path = str_replace("\\","/",$path);
	$path = trailingslashit(get_bloginfo('wpurl')) . trailingslashit(substr($path,strpos($path,"wp-content/")));
	return $path;
}

//Initialize the admin panel
if (!function_exists("buzzZEt_ap")) {
	function buzzZEt_ap() {
		global $bZEt_init;
		if (!isset($bZEt_init)) {
			return;
		}
		if (function_exists('add_options_page')) {
			add_options_page('buzzZ-Et', 'buzzZ-Et', 9, basename(__FILE__), array(&$bZEt_init, 'printAdminPage'));
		}
	}
}

// Truncate the Summary
if (!function_exists("buzzZEt_trunk")) {
	function buzzZEt_trunc($trunc, $tnum) {
		if (strlen($trunc) > 0 && strlen($trunc) > $tnum) {
			$k = 0;
			while ($k >= 0 && $k < strlen($trunc)) {
				$i = strpos($trunc, " ", $k);
				$j = strpos($trunc, chr(10), $k);
				if ($i === FALSE && $j === FALSE) {
					return $trunc;
				} else {
					if ($i > 0 && $j > 0) {
						if ($i < $j) {
							$k = $i;
						} else {
							$k = $j;
						}
					} elseif ($i > 0) {
						$k = $i;
					} elseif ($j > 0) {
						$k = $j;
					}

					if ($k >= $tnum) {
						return substr($trunc, 0, $k) . "...";
					} else {
						$k++;
					}
				}
			}
		} else {
			return $trunc;
		}
	}
}

// Create Button
if (!function_exists("buzzZEt_But")) {
	function buzzZEt_But($content) {
		// Retrieve Options
		$display1 = get_option('bZEt_display1');
		$badge = get_option('bZEt_badge');
		$body = get_option('bZEt_body');
		$media = get_option('bZEt_media');
		$topic = get_option('bZEt_topic');
?>
<?php
// Display Top Right
if($display1 == "") {
	if($badge == "text-votes") {
echo '<div style="float: right; width: 80px; padding-right: 10px; margin: 0 0 10px 10px;">';
	}
	elseif($badge == "logo") {
echo '<div style="float: right; width: 20px; padding-right: 10px; margin: 0 0 10px 10px;">';
	}
	elseif($badge == "text") {
echo '<div style="float: right; width: 78px; padding-right: 10px; margin: 0 0 10px 10px;">';
	}
	elseif($badge == "small-votes" || $badge == "medium-votes" || $badge == "large-votes") {
echo '<div style="float: right; width: 170px; padding-right: 10px; margin: 0 0 0 10px;">';
	}
	elseif($badge == "small" || $badge == "medium" || $badge == "large") {
echo '<div style="float: right; width: 110px; padding-right: 10px; margin: 0 0 0 10px;">';
	}
	else {
echo '<div style="float: right; width: 50px; padding-right: 10px; margin: 0 0 0 10px;">';
	}
}

// Display Top Left
if($display1 == "left") {
	if($badge == "text-votes") {
echo '<div style="float: left; width: 80px; padding-right: 10px; margin: 0 10px 10px 0;">';
	}
	elseif($badge == "logo") {
echo '<div style="float: left; width: 20px; padding-right: 10px; margin: 0 10px 10px 0;">';
	}
	elseif($badge == "text") {
echo '<div style="float: left; width: 78px; padding-right: 10px; margin: 0 10px 10px 0;">';
	}
	elseif($badge == "small-votes" || $badge == "medium-votes" || $badge == "large-votes") {
echo '<div style="float: left; width: 170px; padding-right: 10px; margin: 0 10px 0 0;">';
	}
	elseif($badge == "small" || $badge == "medium" || $badge == "large") {
echo '<div style="float: left; width: 110px; padding-right: 10px; margin: 0 10px 0 0;">';
	}
	else {
echo '<div style="float: left; width: 50px; padding-right: 10px; margin: 0 10px 0 0;">';
	}
}

// Display Bottom Left
if($display1 == "bottomL") {
	if($badge == "square") {
echo '<div style="position:relative; width: 100%; padding: 0 0 100px 0;">';
echo '<div style="position: absolute; bottom: 10px; width: 220px;">';
	}
	else {
echo '<div style="position:relative; width: 100%; padding: 0 0 40px 0;">';
echo '<div style="position: absolute; bottom: 10px; width: 220px;">';
	}
}

// Display Bottom Right
if($display1 == "bottomR") {
	if($badge == "square") {
echo '<div style="position:relative; width: 100%; padding: 0 0 100px 0;">';
echo '<div style="position: absolute; bottom: 10px; right:10px; width: 42px;">';
	}
	elseif($badge == "text-votes" || $badge == "logo" || $badge == "text") {
echo '<div style="position:relative; width: 100%; padding: 0 0 35px 0;">';
echo '<div style="position: absolute; bottom: 10px; right:0; width: 80px;">';
	}
	else {
echo '<div style="position:relative; width: 100%; padding: 0 0 35px 0;">';
echo '<div style="position: absolute; bottom: 10px; right:0; width: 175px;">';
	}
}
?>
<script type="text/javascript">
<!--
yahooBuzzArticleHeadline = '<?php the_title(); ?>';
yahooBuzzArticleSummary = '<?php if($body != "") _e(buzzZEt_trunc(strip_tags(preg_replace("/\\[[^\\]]*\\]/", "", str_replace("\n","", $content))),$body)); ?>';
yahooBuzzArticleCategory = '<?php _e($topic); ?>';
yahooBuzzArticleType = '<?php if (strpos($content, "buzzZM=video") == TRUE) {_e("video");} elseif (strpos($content, "buzzZM=image") == TRUE) {_e("image");} elseif (strpos($content, "buzzZM=text") == TRUE) {_e("text");} else {_e($media);}; ?>';
yahooBuzzArticleId = '<?php the_permalink(); ?>';
//-->
</script>
<script type="text/javascript" src="http://d.yimg.com/ds/badge2.js" badgetype="<?php _e($badge); ?>"> </script>
</div>
<?php
	}
}

// Add Button
if (!function_exists("buzzZEt_AddBut")) {
	function buzzZEt_AddBut($content) {
		$display1 = get_option('bZEt_display1');
		//error_reporting(E_ALL);
		if(is_home() && get_option('bZEt_home') == "checked=on") return $content;
		if(is_single() && get_option('bZEt_post') == "checked=on") return $content;
		if(is_page() && get_option('bZEt_page') == "checked=on") return $content;
		if(is_tag() && get_option('bZEt_tag') == "checked=on") return $content;
		if(is_archive() && get_option('bZEt_arch') == "checked=on") return $content;
		if(is_search() && get_option('bZEt_srch') == "checked=on") return $content;
		if (strpos($content, "buzzZ=none") == TRUE) return $content;
		if($display1 == "bottomL" || $display1 == "bottomR") {
			$content = buzzZEt_But($content).$content;
			if(is_page() || is_single()) {
				if (get_option('bZEt_promote') == "checked=on") {
					$content .= "<p>Yahoo! Buzz buttons brought to you by <a href='http://blog.rswr.net/2008/11/13/yahoo-buzz-wordpress-plugin/'>buzzZ-ET (WordPress Plugin)</a></p></div>";
				} else {
					$content .= '</div>';
				}
			} else {
				$content .= '</div>';
			}
			return $content;
		}
		else {
			$content = buzzZEt_But($content).$content;
			if(is_page() || is_single()) {
				if (get_option('bZEt_promote') == "checked=on") {
					$content .= "<p>Yahoo! Buzz buttons brought to you by <a href='http://blog.rswr.net/2008/11/13/yahoo-buzz-wordpress-plugin/'>buzzZ-ET (WordPress Plugin)</a></p>";
				}
			}
			return $content;
		}
	}
}

// Initialize Class
if (class_exists("buzzZEt")) {
	$bZEt_init = new buzzZEt();
}

//Actions and Filters
if (isset($bZEt_init)) {
	//Actions
	add_action('buzzZ-Et/buzzZ-Et.php', array(&$bZEt_init, 'init'));
	add_action('admin_menu', 'buzzZEt_ap');
	//Filters
	add_filter('the_content', 'buzzZEt_AddBut');
}

?>
